package elemental.js.css;
import elemental.css.CSSValue;
import elemental.css.CSSStyleDeclaration;
import elemental.css.CSSRule;

import com.google.gwt.core.client.GWT;
import com.google.gwt.core.client.JavaScriptObject;

import elemental.events.*;
import elemental.util.*;
import elemental.dom.*;
import elemental.html.*;
import elemental.css.*;
import elemental.js.stylesheets.*;
import elemental.js.events.*;
import elemental.js.util.*;
import elemental.js.dom.*;
import elemental.js.html.*;
import elemental.js.css.*;
import elemental.js.stylesheets.*;

import java.util.Date;

public class JsCSSStyleDeclaration extends JsElementalMixinBase  implements CSSStyleDeclaration {
  protected JsCSSStyleDeclaration() {}

  public final native String getCssText() /*-{
    return this.cssText;
  }-*/;

  public final native void setCssText(String param_cssText) /*-{
    this.cssText = param_cssText;
  }-*/;

  public final native int getLength() /*-{
    return this.length;
  }-*/;

  public final native JsCSSRule getParentRule() /*-{
    return this.parentRule;
  }-*/;

  public final native JsCSSValue getPropertyCSSValue(String propertyName) /*-{
    return this.getPropertyCSSValue(propertyName);
  }-*/;

  public final native String getPropertyPriority(String propertyName) /*-{
    return this.getPropertyPriority(propertyName);
  }-*/;

  public final native String getPropertyShorthand(String propertyName) /*-{
    return this.getPropertyShorthand(propertyName);
  }-*/;

  public final native String getPropertyValue(String propertyName) /*-{
    return this.getPropertyValue(propertyName);
  }-*/;

  public final native boolean isPropertyImplicit(String propertyName) /*-{
    return this.isPropertyImplicit(propertyName);
  }-*/;

  public final native String item(int index) /*-{
    return this.item(index);
  }-*/;

  public final native String removeProperty(String propertyName) /*-{
    return this.removeProperty(propertyName);
  }-*/;

  public final native void setProperty(String propertyName, String value) /*-{
    this.setProperty(propertyName, value);
  }-*/;

  public final native void setProperty(String propertyName, String value, String priority) /*-{
    this.setProperty(propertyName, value, priority);
  }-*/;

public final native String getBackgroundColor() /*-{ return this.backgroundColor; }-*/;
public final native void setBackgroundColor(String value) /*-{ this.backgroundColor = value; }-*/;
public final native void clearBackgroundColor() /*-{ this.backgroundColor = ""; }-*/;
public final native String getBackgroundImage() /*-{ return this.backgroundImage; }-*/;
public final native void setBackgroundImage(String value) /*-{ this.backgroundImage = value; }-*/;
public final native void clearBackgroundImage() /*-{ this.backgroundImage = ""; }-*/;
public final native String getBorderColor() /*-{ return this.borderColor; }-*/;
public final native void setBorderColor(String value) /*-{ this.borderColor = value; }-*/;
public final native void clearBorderColor() /*-{ this.borderColor = ""; }-*/;
public final native String getBorderStyle() /*-{ return this.borderStyle; }-*/;
public final native void setBorderStyle(String value) /*-{ this.borderStyle = value; }-*/;
public final native void clearBorderStyle() /*-{ this.borderStyle = ""; }-*/;
public final native String getBorderWidth() /*-{ return this.borderWidth; }-*/;
public final native void setBorderWidth(String value) /*-{ this.borderWidth = value; }-*/;
public final native void clearBorderWidth() /*-{ this.borderWidth = ""; }-*/;
public final native void setBorderWidth(double value, String unit) /*-{ this.borderWidth = value + unit; }-*/;
public final native String getBottom() /*-{ return this.bottom; }-*/;
public final native void setBottom(String value) /*-{ this.bottom = value; }-*/;
public final native void clearBottom() /*-{ this.bottom = ""; }-*/;
public final native void setBottom(double value, String unit) /*-{ this.bottom = value + unit; }-*/;
public final native String getColor() /*-{ return this.color; }-*/;
public final native void setColor(String value) /*-{ this.color = value; }-*/;
public final native void clearColor() /*-{ this.color = ""; }-*/;
public final native String getCursor() /*-{ return this.cursor; }-*/;
public final native void setCursor(String value) /*-{ this.cursor = value; }-*/;
public final native void clearCursor() /*-{ this.cursor = ""; }-*/;
public final native String getDisplay() /*-{ return this.display; }-*/;
public final native void setDisplay(String value) /*-{ this.display = value; }-*/;
public final native void clearDisplay() /*-{ this.display = ""; }-*/;
public final native String getFontSize() /*-{ return this.fontSize; }-*/;
public final native void setFontSize(String value) /*-{ this.fontSize = value; }-*/;
public final native void clearFontSize() /*-{ this.fontSize = ""; }-*/;
public final native void setFontSize(double value, String unit) /*-{ this.fontSize = value + unit; }-*/;
public final native String getFontStyle() /*-{ return this.fontStyle; }-*/;
public final native void setFontStyle(String value) /*-{ this.fontStyle = value; }-*/;
public final native void clearFontStyle() /*-{ this.fontStyle = ""; }-*/;
public final native String getFontWeight() /*-{ return this.fontWeight; }-*/;
public final native void setFontWeight(String value) /*-{ this.fontWeight = value; }-*/;
public final native void clearFontWeight() /*-{ this.fontWeight = ""; }-*/;
public final native String getHeight() /*-{ return this.height; }-*/;
public final native void setHeight(String value) /*-{ this.height = value; }-*/;
public final native void clearHeight() /*-{ this.height = ""; }-*/;
public final native void setHeight(double value, String unit) /*-{ this.height = value + unit; }-*/;
public final native String getLeft() /*-{ return this.left; }-*/;
public final native void setLeft(String value) /*-{ this.left = value; }-*/;
public final native void clearLeft() /*-{ this.left = ""; }-*/;
public final native void setLeft(double value, String unit) /*-{ this.left = value + unit; }-*/;
public final native String getListStyleType() /*-{ return this.listStyleType; }-*/;
public final native void setListStyleType(String value) /*-{ this.listStyleType = value; }-*/;
public final native void clearListStyleType() /*-{ this.listStyleType = ""; }-*/;
public final native String getMargin() /*-{ return this.margin; }-*/;
public final native void setMargin(String value) /*-{ this.margin = value; }-*/;
public final native void clearMargin() /*-{ this.margin = ""; }-*/;
public final native void setMargin(double value, String unit) /*-{ this.margin = value + unit; }-*/;
public final native String getMarginBottom() /*-{ return this.marginBottom; }-*/;
public final native void setMarginBottom(String value) /*-{ this.marginBottom = value; }-*/;
public final native void clearMarginBottom() /*-{ this.marginBottom = ""; }-*/;
public final native void setMarginBottom(double value, String unit) /*-{ this.marginBottom = value + unit; }-*/;
public final native String getMarginLeft() /*-{ return this.marginLeft; }-*/;
public final native void setMarginLeft(String value) /*-{ this.marginLeft = value; }-*/;
public final native void clearMarginLeft() /*-{ this.marginLeft = ""; }-*/;
public final native void setMarginLeft(double value, String unit) /*-{ this.marginLeft = value + unit; }-*/;
public final native String getMarginRight() /*-{ return this.marginRight; }-*/;
public final native void setMarginRight(String value) /*-{ this.marginRight = value; }-*/;
public final native void clearMarginRight() /*-{ this.marginRight = ""; }-*/;
public final native void setMarginRight(double value, String unit) /*-{ this.marginRight = value + unit; }-*/;
public final native String getMarginTop() /*-{ return this.marginTop; }-*/;
public final native void setMarginTop(String value) /*-{ this.marginTop = value; }-*/;
public final native void clearMarginTop() /*-{ this.marginTop = ""; }-*/;
public final native void setMarginTop(double value, String unit) /*-{ this.marginTop = value + unit; }-*/;
public final native double getOpacity() /*-{ return this.opacity; }-*/;
public final native void setOpacity(double value) /*-{ this.opacity = value; }-*/;
public final native void clearOpacity() /*-{ this.opacity = ""; }-*/;
public final native String getOverflow() /*-{ return this.overflow; }-*/;
public final native void setOverflow(String value) /*-{ this.overflow = value; }-*/;
public final native void clearOverflow() /*-{ this.overflow = ""; }-*/;
public final native String getOverflowX() /*-{ return this.overflowX; }-*/;
public final native void setOverflowX(String value) /*-{ this.overflowX = value; }-*/;
public final native void clearOverflowX() /*-{ this.overflowX = ""; }-*/;
public final native String getOverflowY() /*-{ return this.overflowY; }-*/;
public final native void setOverflowY(String value) /*-{ this.overflowY = value; }-*/;
public final native void clearOverflowY() /*-{ this.overflowY = ""; }-*/;
public final native String getPadding() /*-{ return this.padding; }-*/;
public final native void setPadding(String value) /*-{ this.padding = value; }-*/;
public final native void clearPadding() /*-{ this.padding = ""; }-*/;
public final native void setPadding(double value, String unit) /*-{ this.padding = value + unit; }-*/;
public final native String getPaddingBottom() /*-{ return this.paddingBottom; }-*/;
public final native void setPaddingBottom(String value) /*-{ this.paddingBottom = value; }-*/;
public final native void clearPaddingBottom() /*-{ this.paddingBottom = ""; }-*/;
public final native void setPaddingBottom(double value, String unit) /*-{ this.paddingBottom = value + unit; }-*/;
public final native String getPaddingLeft() /*-{ return this.paddingLeft; }-*/;
public final native void setPaddingLeft(String value) /*-{ this.paddingLeft = value; }-*/;
public final native void clearPaddingLeft() /*-{ this.paddingLeft = ""; }-*/;
public final native void setPaddingLeft(double value, String unit) /*-{ this.paddingLeft = value + unit; }-*/;
public final native String getPaddingRight() /*-{ return this.paddingRight; }-*/;
public final native void setPaddingRight(String value) /*-{ this.paddingRight = value; }-*/;
public final native void clearPaddingRight() /*-{ this.paddingRight = ""; }-*/;
public final native void setPaddingRight(double value, String unit) /*-{ this.paddingRight = value + unit; }-*/;
public final native String getPaddingTop() /*-{ return this.paddingTop; }-*/;
public final native void setPaddingTop(String value) /*-{ this.paddingTop = value; }-*/;
public final native void clearPaddingTop() /*-{ this.paddingTop = ""; }-*/;
public final native void setPaddingTop(double value, String unit) /*-{ this.paddingTop = value + unit; }-*/;
public final native String getPosition() /*-{ return this.position; }-*/;
public final native void setPosition(String value) /*-{ this.position = value; }-*/;
public final native void clearPosition() /*-{ this.position = ""; }-*/;
public final native String getRight() /*-{ return this.right; }-*/;
public final native void setRight(String value) /*-{ this.right = value; }-*/;
public final native void clearRight() /*-{ this.right = ""; }-*/;
public final native void setRight(double value, String unit) /*-{ this.right = value + unit; }-*/;
public final native String getTextDecoration() /*-{ return this.textDecoration; }-*/;
public final native void setTextDecoration(String value) /*-{ this.textDecoration = value; }-*/;
public final native void clearTextDecoration() /*-{ this.textDecoration = ""; }-*/;
public final native String getTop() /*-{ return this.top; }-*/;
public final native void setTop(String value) /*-{ this.top = value; }-*/;
public final native void clearTop() /*-{ this.top = ""; }-*/;
public final native void setTop(double value, String unit) /*-{ this.top = value + unit; }-*/;
public final native String getVisibility() /*-{ return this.visibility; }-*/;
public final native void setVisibility(String value) /*-{ this.visibility = value; }-*/;
public final native void clearVisibility() /*-{ this.visibility = ""; }-*/;
public final native String getWhiteSpace() /*-{ return this.whiteSpace; }-*/;
public final native void setWhiteSpace(String value) /*-{ this.whiteSpace = value; }-*/;
public final native void clearWhiteSpace() /*-{ this.whiteSpace = ""; }-*/;
public final native String getWidth() /*-{ return this.width; }-*/;
public final native void setWidth(String value) /*-{ this.width = value; }-*/;
public final native void clearWidth() /*-{ this.width = ""; }-*/;
public final native void setWidth(double value, String unit) /*-{ this.width = value + unit; }-*/;
public final native int getZIndex() /*-{ return this.zIndex; }-*/;
public final native void setZIndex(int value) /*-{ this.zIndex = value; }-*/;
public final native void clearZIndex() /*-{ this.zIndex = ""; }-*/;
}